/*
 * Author: CM
 */
(function($) {
  $.fn.extend({
    disable: function(message) {
      $.blockUI.defaults.overlayCSS = {opacity: 0};
      $.blockUI.defaults.css = {};
      return this.each(function() {
        $(this).block({
          fadeIn: 50,
          message: message ? message : null
        });
      });
    },

    enable: function() {
      return this.each(function() {
        $(this).unblock({
          fadeOut: 0
        });
      });
    },

    scrollBottom: function() {
      this.each(function() {
        $(this).scrollTop($(this).getScrollHeight());
      });
    },

    getScrollHeight: function() {
      if (0 === this.length) {
        return null;
      }
      var element = this[0];
      if (element === document || element === window) {
        return $(document.body).prop('scrollHeight');
      } else {
        return this.prop('scrollHeight');
      }
    },

    /**
     * @param {jQuery} $target
     * @returns {jQuery}
     */
    scrollTo: function($target) {
      if ($target.length == 0) {
        return;
      }
      var target = $target[0];

      return this.each(function() {
        var scrollable = this;
        var scrollableOffsetTop = 0;
        if (scrollable !== document) {
          if (!$.contains(scrollable, target)) {
            throw new Error('Scrollable does not contain target');
          }
          scrollableOffsetTop = $(scrollable).offset().top;
        }
        $(scrollable).scrollTop($target.offset().top - scrollableOffsetTop + $(scrollable).scrollTop());
      });
    },

    nextOrFirst: function(selector) {
      if (this.next(selector).length) {
        return this.next(selector);
      } else {
        return this.siblings(selector).length > 0 ? this.siblings(selector).filter(':first') : this;
      }
    },
    prevOrLast: function(selector) {
      if (this.prev(selector).length) {
        return this.prev(selector);
      } else {
        return this.siblings(selector).length > 0 ? this.siblings(selector).filter(':last') : this;
      }
    },

    findAndSelf: function(selector) {
      return this.find(selector).add(this.filter(selector));
    },

    triggerReflow: function() {
      return this.each(function() {
        // Force reflow for CSS-animation
        this.offsetWidth;
      });
    }
  });
})(jQuery);
